Name: gdk-pixbuf
Version: 0.22.0
Release: 18.fc4.2
Epoch: 1
Summary: An image loading library used with GNOME.
License: LGPL
Group: System Environment/Libraries
Source: ftp://ftp.gnome.org/pub/GNOME/sources/stable/%{name}/%{name}-%{version}.tar.bz2
Source2: local-hack-gmodule2.tar.gz

#
# Define for building with libtool older than 1.5
#
#%define old_libtool 1
#
# Need /usr/lib/*.la for AS2.1
#
#%define include_la 1
#
# Define for building without gnome support
# Fedora needs gnome support, RHEL not
#
%define build_gnome 1

Patch2: gdk-pixbuf-0.18.0-gmodulehack.patch
# Quote in configure.in appropriately for recent libtool
Patch3: gdk-pixbuf-0.22.0-acquote.patch
# Fixup gmodulehack for libtool-1.5
Patch4: gdk-pixbuf-0.22.0-libtool15.patch
# Patches backported from GTK+ HEAD
Patch5: gdk-pixbuf-0.22.0-bmp-colormap.patch
Patch6: gdk-pixbuf-0.22.0-ico-width.patch
Patch7: gdk-pixbuf-underquoted.patch
# http://bugzilla.gnome.org/show_bug.cgi?id=150601
Patch8: gdk-pixbuf-0.22.0-bmploop.patch
# Hack: don't build gnomecanvaspixbuf
Patch9: gdk-pixbuf-0.22.0-nognome.patch
# http://bugzilla.gnome.org/show_bug.cgi?id=130711
Patch10: gdk-pixbuf-0.22.0-loaders.patch
Patch11: gtk+-2.2.2-noexecstack.patch
Patch12: gdk-pixbuf-0.22.0-bmpcrash.patch
Patch13: gdk-pixbuf-0.22.0-xpm-ncol-overflow.patch
Patch14: gdk-pixbuf-0.22.0-xpm-whc-overflow.patch
Patch15: gdk-pixbuf-0.22.0-xpm-largecol.patch

URL: http://www.gnome.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%if %{build_gnome}
BuildPrereq: gnome-libs-devel
%endif
BuildRequires: autoconf
BuildRequires: libtool
#
# AS2.1
#BuildPrereq: /usr/bin/automake
#define old_automake 1
#
# Modern releases:
%define old_automake 0
BuildPrereq: /usr/bin/automake-1.4
BuildRequires: libpng-devel >= 1.2.2

%description
The gdk-pixbuf package contains an image loading library used with the
GNOME GUI desktop environment. The GdkPixBuf library provides image
loading facilities, the rendering of a GdkPixBuf into various formats
(drawables or GdkRGB buffers), and a cache interface.

%package devel
Summary: Files needed for developing apps to work with the GdkPixBuf library.
Group: Development/Libraries
Requires:	%{name} = %{epoch}:%{version}
%if %{build_gnome}
Requires:	%{name}-gnome = %{epoch}:%{version}
Requires:       gnome-libs-devel
%endif

%description devel
This package contains the libraries, header files, and include files
needed for developing applications that will work with the GdkPixBuf
image loading library.

%package gnome
Summary: GnomeCanvas support for displaying images.
Group: System Environment/Libraries
Requires: %{name} = %{epoch}:%{version}

%description gnome
GNOME-dependent portions of the gdk-pixbuf image loading library.


%prep
%setup -q

%patch2 -p1 -b .gmodulehack
%patch3 -p1 -b .acquote

(cd gdk-pixbuf && tar zxf %{SOURCE2})

%if ! %{old_libtool}
%patch4 -p1 -b .libtool15
%endif

%patch5 -p1 -b .bmp-colormap
%patch6 -p1 -b .ico-width
%patch7 -p1 -b .underquoted
%patch8 -p1 -b .bmploop

%if %{build_gnome}
%else
%patch9 -p1 -b .nognome
%endif

%patch10 -p1 -b .loaders
%patch11 -p1 -b .noexecstack
%patch12 -p1 -b .bmpcrash
%patch13 -p1 -b .xpm-ncol-overflow
%patch14 -p1 -b .xpm-whc-overflow
%patch15 -p1 -b .xpm-largecol

perl -p -i.bak -e 's/gmodule.h/gmodule-local.h/g; s/g_module/local_hack_g_module/g; s/GModule/LocalHackGModule/g; s/G_MODULE/LOCAL_HACK_G_MODULE/g' gdk-pixbuf/gdk-pixbuf-io.c gdk-pixbuf/gdk-pixbuf-io.h
perl -pi -e 's/-static//g' gdk-pixbuf/local-hack-gmodule/Makefile

%build
libtoolize --copy --force
%if %{old_automake}
aclocal
automake --add-missing 
%else
aclocal-1.4
automake-1.4
%endif
autoconf

(cd gdk-pixbuf/local-hack-gmodule && make && cp gmodule-local.h ..)

CFLAGS="$RPM_OPT_FLAGS" ./configure	\
	--prefix=%{_prefix} --sysconfdir=%{_sysconfdir}	 --libdir=%{_libdir}\
	--localstatedir=%{_localstatedir} --disable-gtk-doc

make

%install
rm -rf $RPM_BUILD_ROOT
make prefix=$RPM_BUILD_ROOT/%{_prefix} \
	sysconfdir=$RPM_BUILD_ROOT/%{_sysconfdir} libdir=$RPM_BUILD_ROOT/%{_libdir}\
	localstatedir=$RPM_BUILD_ROOT/%{_localstatedir} install

%if ! %{include_la}
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
%endif
rm -f $RPM_BUILD_ROOT%{_libdir}/gdk-pixbuf/loaders/*.la

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%post gnome -p /sbin/ldconfig
%postun gnome -p /sbin/ldconfig

%files
%defattr (-, root, root)

%doc AUTHORS COPYING COPYING.LIB ChangeLog NEWS README TODO doc/*.txt doc/html

%{_libdir}/libgdk_pixbuf*.so.*
%dir %{_libdir}/gdk-pixbuf
%dir %{_libdir}/gdk-pixbuf/loaders
%{_libdir}/gdk-pixbuf/loaders/lib*.so*

%if %{build_gnome}
%files gnome
%defattr (-, root, root)
%{_libdir}/libgnomecanvaspixbuf*.so.*
%endif

%files devel
%defattr (-, root, root)
%{_includedir}/*
%{_bindir}/gdk-pixbuf-config

%{_libdir}/*so
%{_libdir}/*.a
%if %{include_la}
%{_libdir}/*.la
%endif
%{_libdir}/gdk-pixbuf/loaders/lib*.a
%{_libdir}/*Conf.sh
%{_datadir}/aclocal/*
%{_datadir}/gnome/html/*

%changelog
* Mon Oct 31 2005 Matthias Clasen <mclasen@redhat.com> - 1:0.22.0-18.fc4.2
- Prevent another integer overflow in the xpm loader (#171901, CVE-2005-2976)
- Prevent an infinite loop in the xpm loader (#171901, CVE-2005-2976)

* Wed Oct 19 2005 Matthias Clasen <mclasen@redhat.com> - 1:0.22.0-18.fc4.1
- Prevent an integer overflow in the xpm loader (#171073, CVE-2005-3186)

* Mon Mar 28 2005 Matthias Clasen <mclasen@redhat.com> - 1:0.22.0-18
- Fix a double free in the bmp loader

* Mon Mar  7 2005 Matthias Clasen <mclasen@redhat.com> - 1:0.22.0-17
- Mark libraries as non-execstack

* Wed Mar  2 2005 Matthias Clasen <mclasen@redhat.com> - 1:0.22.0-16
- Rebuild with gcc4

* Fri Sep 24 2004 Matthias Clasen <mclasen@redhat.com> - 1:0.22.0-15.1
- Rebuild for RHEL4 without gnome support.

* Fri Sep 24 2004 Matthias Clasen <mclasen@redhat.com> - 1:0.22.0-15.0
- Rebuild for FC3 with gnome support.

* Wed Sep 15 2004 Matthias Clasen <mclasen@redhat.com> - 1:0.22.0-14
- Fix a bug in the last change which broke the xpm loader
- build without gnome support

* Wed Sep 15 2004 Matthias Clasen <mclasen@redhat.com> - 1:0.22.0-12
- Rebuild for FC3

* Tue Sep 14 2004 Bill Nottingham <notting@redhat.com> - 1:0.22.0-11
- build without gnome support

* Fri Aug 20 2004 Owen Taylor <otaylor@redhat.com> - 1:0.22.0-10.1.3
- Bump and rebuild for FC3

* Fri Aug 20 2004 Owen Taylor <otaylor@redhat.com> - 1:0.22.0-10.1.2
- Bump and rebuild for FC2

* Fri Aug 20 2004 Owen Taylor <otaylor@redhat.com> - 1:0.22.0-10.1.1
- Bump and build for FC1

* Fri Aug 20 2004 Owen Taylor <otaylor@redhat.com> - 1:0.22.0-10.0.3
- Bump and rebuild for 3.0E

* Fri Aug 20 2004 Owen Taylor <otaylor@redhat.com> - 1:0.22.0-10.0.2E
- Fix problem with infinite loop on bad BMP data (#130455,
  test BMP from Chris Evans, fix from Manish Singh)

* Sun Aug 15 2004 Tim Waugh <twaugh@redhat.com> 1:0.22.0-9
- Fixed underquoted m4 definition.

* Mon Jun 21 2004 Matthias Clasen <mclasen@redhat.com>
- Make build

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Mar  5 2004 Owen Taylor <otaylor@redhat.com> 1:0.22.0-6.0.3
- Include /usr/lib/*.la for AS2.1

* Fri Mar  5 2004 Owen Taylor <otaylor@redhat.com> 1:0.22.0-6.0.2E
- Add some additional defines to work with 2.1AS

* Thu Mar  4 2004 Owen Taylor <otaylor@redhat.com> 1:0.22.0-6.1.1
- Bump and rebuild

* Thu Mar  4 2004 Owen Taylor <otaylor@redhat.com> 1:0.22.0-6.1.0
- Redo package to build without libtool-1.5 patch

* Wed Mar  3 2004 Owen Taylor <otaylor@redhat.com> 1:0.22.0-6.0.0
- Add a couple of bug-fixes backported from GTK+-2.x

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu Aug 28 2003 Owen Taylor <otaylor@redhat.com> 1:0.22.0-4.0
- Rebuild for RHEL

* Wed Jul  9 2003 Owen Taylor <otaylor@redhat.com> 1:0.22.0-3.0
- Remove specific version from libtool requires

* Tue Jul  8 2003 Owen Taylor <otaylor@redhat.com> 1:0.22.0-2.0
- Bump for rebuild

* Thu Jun 12 2003 Owen Taylor <otaylor@redhat.com> 1:0.22.0-1
- Version 0.22.0

* Sun Jun  8 2003 Tim Powers <timp@redhat.com> 1:0.18.0-8.1
- build for RHEL

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Jun  3 2003 Jeff Johnson <jbj@redhat.com>
- add explicit epoch's where needed.

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Fri Jan  3 2003 Owen Taylor <otaylor@redhat.com>
- BuildRequires libtool (#80947, Alan)

* Thu Nov  7 2002 Jeremy Katz <katzj@redhat.com> 
- rebuild to fix X11 libdir on multilib arches
- use %%libdir, etc

* Tue Aug 27 2002 Elliot Lee <sopwith@redhat.com>
- Patch3 for #65823

* Tue Aug 13 2002 Havoc Pennington <hp@redhat.com>
- fix warnings about unpackaged files (originally I was also fixing 
  libpng stuff but realized there was nothing to fix)

* Fri Jul 19 2002 Jakub Jelinek <jakub@redhat.com>
- remove -static from local-hack-gmodule Makefile, so that
  the shared libraries aren't DT_TEXTREL

* Fri Jul 12 2002 Havoc Pennington <hp@redhat.com>
- 0.18

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Jun 19 2002 Jeremy Katz <katzj@redhat.com>
- remove .la files

* Sun May 26 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Fri May 17 2002 Alex Larsson <alexl@redhat.com>
- Use autoconf 2.13

* Thu Feb 28 2002 Havoc Pennington <hp@redhat.com>
- backport to Hampton

* Thu Feb  7 2002 Havoc Pennington <hp@redhat.com>
- remove CPPFLAGS=-I/usr/include/png-1.0

* Thu Feb  7 2002 Havoc Pennington <hp@redhat.com>
- remove libpng10 linkage, add hack to dlopen without RTLD_GLOBAL

* Wed Jan 30 2002 Bill Nottingham <notting@redhat.com>
- bump release
- png1.0 stuff

* Wed Jan 23 2002 Havoc Pennington <hp@redhat.com>
- fix some prefix/lib->libdir type of stuff
- rebuild for db1 issues

* Wed Dec 19 2001 Jeremy Katz <katzj@redhat.com>
- 0.14

* Mon Oct 29 2001 Havoc Pennington <hp@redhat.com>
- 0.13

* Sat Oct  6 2001 Havoc Pennington <hp@redhat.com>
- fix glitch in my header relocation patch

* Fri Oct  5 2001 Havoc Pennington <hp@redhat.com>
- cvs snap with headers relocated

* Fri Aug  3 2001 Owen Taylor <otaylor@redhat.com>
- Add dependency on gnome-libs-devel for the -devel package (#45020)

* Fri Jul 20 2001 Owen Taylor <otaylor@redhat.com>
- Own /usr/lib/gdk-pixbuf, /usr/lib/gdk-pixbuf/loaders (#27423)
- Add BuildPrereq on gnome-libs-devel (#49444)
- Add --disable-gtk-doc (#48988)

* Tue Jul 10 2001 Trond Eivind Glomsrd <teg@redhat.com>
- Add post/postun for gnome subpackage

* Thu Jul 05 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- add patch to cope with newer "file" version

* Mon Jun 11 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- copy config.{guess,sub} instead of calling libtoolize

* Wed Jun  6 2001 Trond Eivind Glomsrd <teg@redhat.com>
- Remember to set ownership in gnome subpackage

* Wed Jun 06 2001 Havoc Pennington <hp@redhat.com>
- Split out the gnome part into a separate package
- 0.11 upgrade
- don't libtoolize

* Tue Apr 17 2001 Jonathan Blandford <jrb@redhat.com>
- New Version.

* Thu Mar 01 2001 Owen Taylor <otaylor@redhat.com>
- Rebuild for GTK+-1.2.9 include paths

* Thu Feb 08 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- add libtoolize to make porting to new archs easy

* Fri Aug 11 2000 Jonathan Blandford <jrb@redhat.com>
- Up Epoch and release

* Wed Aug  2 2000 Matt Wilson <msw@redhat.com>
- rebuilt against new libpng

* Thu Jul 13 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Thu Jun 29 2000 Owen Taylor <otaylor@redhat.com>
- Specfile fixes

* Thu Jun 15 2000 Owen Taylor <otaylor@redhat.com>
- Version 0.8.0

* Sat May  6 2000 Matt Wilson <msw@redhat.com>
- Red Hat-ified helix gdk-pixbuf RPM



